// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockLifecycleTemplates is an autogenerated mock type for the LifecycleTemplates type
type MockLifecycleTemplates struct {
	mock.Mock
}

// CreateLifecycleTemplate provides a mock function with given fields: ctx, lifecycleTemplate
func (_m *MockLifecycleTemplates) CreateLifecycleTemplate(ctx context.Context, lifecycleTemplate *models.LifecycleTemplate) (*models.LifecycleTemplate, error) {
	ret := _m.Called(ctx, lifecycleTemplate)

	if len(ret) == 0 {
		panic("no return value specified for CreateLifecycleTemplate")
	}

	var r0 *models.LifecycleTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.LifecycleTemplate) (*models.LifecycleTemplate, error)); ok {
		return rf(ctx, lifecycleTemplate)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.LifecycleTemplate) *models.LifecycleTemplate); ok {
		r0 = rf(ctx, lifecycleTemplate)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.LifecycleTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.LifecycleTemplate) error); ok {
		r1 = rf(ctx, lifecycleTemplate)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetLifecycleTemplateByID provides a mock function with given fields: ctx, id
func (_m *MockLifecycleTemplates) GetLifecycleTemplateByID(ctx context.Context, id string) (*models.LifecycleTemplate, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetLifecycleTemplateByID")
	}

	var r0 *models.LifecycleTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.LifecycleTemplate, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.LifecycleTemplate); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.LifecycleTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetLifecycleTemplateByPRN provides a mock function with given fields: ctx, prn
func (_m *MockLifecycleTemplates) GetLifecycleTemplateByPRN(ctx context.Context, prn string) (*models.LifecycleTemplate, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetLifecycleTemplateByPRN")
	}

	var r0 *models.LifecycleTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.LifecycleTemplate, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.LifecycleTemplate); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.LifecycleTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetLifecycleTemplates provides a mock function with given fields: ctx, input
func (_m *MockLifecycleTemplates) GetLifecycleTemplates(ctx context.Context, input *GetLifecycleTemplatesInput) (*LifecycleTemplatesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetLifecycleTemplates")
	}

	var r0 *LifecycleTemplatesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetLifecycleTemplatesInput) (*LifecycleTemplatesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetLifecycleTemplatesInput) *LifecycleTemplatesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*LifecycleTemplatesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetLifecycleTemplatesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateLifecycleTemplate provides a mock function with given fields: ctx, releaseLifecycleTemplate
func (_m *MockLifecycleTemplates) UpdateLifecycleTemplate(ctx context.Context, releaseLifecycleTemplate *models.LifecycleTemplate) (*models.LifecycleTemplate, error) {
	ret := _m.Called(ctx, releaseLifecycleTemplate)

	if len(ret) == 0 {
		panic("no return value specified for UpdateLifecycleTemplate")
	}

	var r0 *models.LifecycleTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.LifecycleTemplate) (*models.LifecycleTemplate, error)); ok {
		return rf(ctx, releaseLifecycleTemplate)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.LifecycleTemplate) *models.LifecycleTemplate); ok {
		r0 = rf(ctx, releaseLifecycleTemplate)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.LifecycleTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.LifecycleTemplate) error); ok {
		r1 = rf(ctx, releaseLifecycleTemplate)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockLifecycleTemplates creates a new instance of MockLifecycleTemplates. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockLifecycleTemplates(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockLifecycleTemplates {
	mock := &MockLifecycleTemplates{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
